﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace WebServer
{
    class WebServer
    {
        static void Main(string[] args)
        {
            new WebServer();
        }

        private Thread m_MainProcess;
        private Socket m_ServerSocket;
        public WebServer()
        {
            m_MainProcess = new Thread(new ThreadStart(MainThread));
            m_MainProcess.Start();

            IPEndPoint ipep = new IPEndPoint(IPAddress.Any, 8080);
            m_ServerSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            m_ServerSocket.Bind(ipep);
            m_ServerSocket.Listen(20);

            SocketAsyncEventArgs args = new SocketAsyncEventArgs();
            args.Completed += new EventHandler<SocketAsyncEventArgs>(Accpet_Completed);
            m_ServerSocket.AcceptAsync(args);


        }

        private void Accpet_Completed(object sender, SocketAsyncEventArgs e)
        {
            Socket client = e.AcceptSocket;
            Socket server = (Socket)sender;

            if (client != null)
            {
                SocketAsyncEventArgs args = new SocketAsyncEventArgs();
                byte[] szBuffer = new byte[4096];
                args.SetBuffer(szBuffer, 0, 4096);
                args.UserToken = client;
                args.Completed += new EventHandler<SocketAsyncEventArgs>(Recieve_Completed);
                client.ReceiveAsync(args);
            }
            
            e.AcceptSocket = null;
            server.AcceptAsync(e);
        }

        private void Recieve_Completed(object sender, SocketAsyncEventArgs e)
        {
            byte[] pBuffer = e.Buffer;
            String sHttpText = Encoding.UTF8.GetString(pBuffer);
            sHttpText = sHttpText.Trim();
            sHttpText = sHttpText.Replace("\0", "");
            Console.WriteLine(sHttpText);
            int nPos = sHttpText.IndexOf(" ")+1;
            int nEPos = sHttpText.IndexOf(" ", nPos);
            if (nPos < 0 || nEPos < 0) return;
            String fileName = sHttpText.Substring(nPos,nEPos - nPos);
            nPos = sHttpText.IndexOf("Accept",nPos);
            nEPos = sHttpText.IndexOf("\n", nPos);
            String AcceptType = sHttpText.Substring(nPos, nEPos - nPos);

            //String html = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\"><html xmlns=\"http://www.w3.org/1999/xhtml\"><head><title>Protocal Test</title></head><body>Hello World!!</body></html>";

            StringBuilder strBuffer = new StringBuilder();

            strBuffer.Append("HTTP/1.1 200 OK\r\n");
            strBuffer.Append("Cache-Control: private\r\n");
            strBuffer.Append("Content-Type: text/html; charset=utf-8\r\n");
            strBuffer.Append("Server: SYWebServer - 1.00\r\n");
            //strBuffer.AppendFormat("Content-Length: {0}\r\n", html.Length);
            //strBuffer.Append("\r\n");
            //strBuffer.Append(html);
            byte[] data = FileRead(fileName, ref strBuffer);
            if (data != null && data.Length > 0)
            {
                String Header = strBuffer.ToString();
                pBuffer = Encoding.Default.GetBytes(Header);
               
                SocketAsyncEventArgs args = new SocketAsyncEventArgs();
                args.SetBuffer(data, 0, data.Length);
                args.Completed += new EventHandler<SocketAsyncEventArgs>(Send_Completed);
                Socket client = (Socket)sender;
                client.Send(pBuffer);
                client.SendAsync(args);
            }
        }
        
        private byte[] FileRead(string filename,ref StringBuilder sb)
        {
            filename.Replace("/","\\");
            if (filename.CompareTo("/") == 0)
            {
                filename += "Default.html";
            }

            try
            {
                FileStream FS = new FileStream("c:\\Web" + filename, FileMode.Open, FileAccess.Read);
                byte[] pBuffer = new byte[FS.Length];
                FS.Read(pBuffer, 0, pBuffer.Length);
                FS.Close();
                sb.AppendFormat("Content-Length: {0}\r\n", pBuffer.Length);
                sb.Append("\r\n");
                return pBuffer;
            }
            catch (FileNotFoundException e)
            {
                return null;
            }
        }
        private void Send_Completed(object sender, SocketAsyncEventArgs e)
        {
            Socket client = (Socket)sender;
            client.Disconnect(true);
            client.Close();
        }
        public void MainThread()
        {
            while (true)
            {
                //Console.Write("Command>");
                string cmd = Console.ReadLine();
                if (cmd.Trim().CompareTo("exit") == 0)
                {
                    m_MainProcess.Abort();
                    break;
                }
            }
        }
    }
}
